{* <!-- макет страницы без центральной части --> *}{strip}

    {* <!-- =======================================================================
    |                                                                             |
    |  Проверяем неучтенные случаи "Ошибка 404".                                  |
    |                                                                             |
    ======================================================================== --> *}

    {include 'common/check404.htm'}

    {* <!-- =======================================================================
    |                                                                             |
    |  Может модуль сообщил, что выбран какой-то элемент меню и нужно подсветить? |
    |                                                                             |
    ======================================================================== --> *}

    {$id = $menuSelectedId|default:0}

    {* <!-- =======================================================================
    |                                                                             |
    |  Непосредственно разметка.                                                  |
    |                                                                             |
    ======================================================================== --> *}

<!DOCTYPE html>
    <html lang="ru" class="no-js">
        <head>
            <base href="{site}" />
            <meta charset="UTF-8" />
            <meta http-equiv="X-UA-Compatible" content="IE=edge" />
            <meta name="viewport" content="width=device-width, initial-scale=1" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Мета заголовок, ключи, описание.                                   |
            |                                                                     |
            ================================================================ --> *}

            <title>{title}</title>
            <meta content="{inputValue from=description}" name="description" />
            <meta content="{inputValue from=keywords}" name="keywords" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Ярлыковая иконка.                                                  |
            |                                                                     |
            ================================================================ --> *}

            <link href="{theme}images/favicon.ico" rel="shortcut icon" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Метка генератора страницы.                                         |
            |                                                                     |
            ================================================================ --> *}

            {$verMM = $smarty.const.IMPERA_CMS_CURRENT_MMVERSION|default:''}
            {$verYMD = $smarty.const.IMPERA_CMS_CURRENT_VERSION|default:''}
            <meta name="generator" content="Impera CMS {$verMM} ({$verYMD})" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Автор контента страницы (логично, что им является магазин).        |
            |                                                                     |
            ================================================================ --> *}

            <meta name="author" content="{inputValue from='settings->site_name'}" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Стили.                                                             |
            |                                                                     |
            ================================================================ --> *}

            <link href="{theme}css/style.css" rel="stylesheet" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Скрипты (остальные подключаем внизу разметки для ускорения).       |
            |                                                                     |
            ================================================================ --> *}

            <script src="{theme}js/modernizr.custom.js"></script>

            {* <!-- ===============================================================
            |                                                                     |
            |  Основной модуль мог попросить добавить некоторые мета-теги.        |
            |                                                                     |
            ================================================================ --> *}

            {echoVar from=meta}
        </head>

        <body>
            <div class="container">
                <div class="hero">
                    <div class="hero__back hero__back--static"></div>
                    <div class="hero__back hero__back--mover"></div>
                    <div class="hero__front"></div>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Форма поиска.                                                  |
                |                                                                 |
                ============================================================ --> *}

                <div class="hero-text">
                    <div>
                        <form class="form search" action="search" method="post">
                            <label class="required">
                                <input name="keyword" type="text" value="{inputValue from=keyword}" maxlength="48" placeholder="что найти..." required />
                            </label>
                            <input name="reset_old" type="hidden" value="1" />
                            <a class="flaticon-search" href="{site}" onclick="return submitSearch(this)" title="Найти"><span>Найти</span></a>
                            <small>
                                <i class="flaticon-address"></i><a href="search">история поиска</a>
                            </small>
                        </form>

                        Представляем лёгкий адаптивный шаблон сайта-витрины фототоваров с концепцией работы в пределах одного экрана.
                    </div>

                    <p>
                        <span>
                            <a class="button {if $id == 4} active {/if}" href="news">Новости</a>
                            <a class="button {if $id == 5} active {/if}" href="articles">Обзоры</a>
                        </span>
                        На главной нижняя часть тянется влево-вправо и содержит группы товаров по брендам.<br />
                        <a class="button {if $id == 6} active {/if}" href="categories" title="Каталог по разделам">По разделам</a><br />
                        <small><i class="flaticon-address"></i> <a href="sitemap">карта сайта</a></small><br />
                        <small><i class="flaticon-cart"></i> <a href="cart">корзина</a></small><br />
                        <small><i class="flaticon-tag"></i> <a href="products">товар</a></small>
                    </p>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Шапка.                                                         |
                |                                                                 |
                ============================================================ --> *}

                <header>
                    <div class="signpost">
                        <a class="flaticon-return" href="{site}" onclick="return backHistory()" title="Предыдущая страница"><span>Предыдущая страница</span></a>
                        <a class="flaticon-home" href="{site}" title="Главная страница"><span>На главную страницу</span></a>
                    </div>

                    <h1><span>Стильный магазин</span> <span>фототоваров</span></h1>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Верхнее меню (справа).                                     |
                    |                                                             |
                    ======================================================== --> *}

                    <nav class="menu">
                        <a {if $id == 1} class="active" {/if} href="about" title="О нашем магазине"><span>О нас</span></a>
                        <a {if $id == 2} class="active" {/if} href="{site}" title="Каталог по производителям"><span>Каталог</span></a>
                        <a {if $id == 3} class="active" {/if} href="feedback" title="Наши контакты"><span>Контакты</span></a>
                    </nav>
                </header>

                {* <!-- ===========================================================
                |                                                                 |
                |  Контент основного модуля.                                      |
                |                                                                 |
                ============================================================ --> *}

                <div class="stack-slider">
                    <div class="wrapper">
                        {content}
                    </div>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Индикатор загрузки.                                            |
                |                                                                 |
                ============================================================ --> *}

                <img class="loader" src="{theme}images/three-dots.svg" width="60" alt="Индикатор загрузки" />

                {* <!-- ===========================================================
                |                                                                 |
                |  Подвал (имя сайта + счетчики метрики, аналитики и т.п.).       |
                |                                                                 |
                ============================================================ --> *}

                <footer>
                    <span>&copy; {$smarty.now|date_format:'%Y'} {echoVar from='settings->site_name'}</span>
                    <div class="counters">{echoVar from='settings->counters'}</div>

                    <a href="https://tookapic.com/pawelkadysz/10163-hello" target="_blank" rel="nofollow" title="Фоновое изображение">TookAPic</a>
                    <a href="http://www.flaticon.com/categories/" target="_blank" rel="nofollow" title="Иконки">FlatIcon</a>
                    <a href="http://flickity.metafizzy.co" target="_blank" rel="nofollow" title="Слайдер">Flickity</a>
                    <a href="http://tympanus.net/codrops/" target="_blank" rel="nofollow" title="Концепция дизайна">Codrops</a>

                    <a href="http://imperacms.ru" target="_blank" rel="nofollow" title="Скрипт магазина">Impera CMS</a>
                </footer>
            </div>

            {* <!-- ===============================================================
            |                                                                     |
            |  Скрипты (также те, что модули могли занести в $otherJS).           |
            |                                                                     |
            ================================================================ --> *}

            <script src="{theme}js/flickity.pkgd.min.js"></script>
            <script src="{theme}js/smoothscroll.js"></script>
            {echoVar from=otherJS}
            <script src="{theme}js/script.js"></script>
        </body>
    </html>

{/strip}