/* ================================================================================
  Система: Impera CMS                                                             |
  Сайт системы: http://imperacms.ru/                                              |
                                                                                  |
  Назначение файла: основной скрипт                                               |
  Расположение: http://сайт/design/папка_шаблона/js/script.js                     |
  Предназначен для шаблона: Photographer (PhotographyWebsiteConcept)              |
                                                                                  |
  ------------------------------------------------------------------------------- |
                                                                                  |
  Автор шаблона: Codrops                                                          |
        пост: http://tympanus.net/codrops/2015/05/06/photography-website-concept/ |
        демо: http://tympanus.net/Development/PhotographyWebsiteConcept/          |
        лицензия: GNU GPL license v3 (https://www.gnu.org/licenses/gpl-3.0.html)  |
                                                                                  |
  Благодарности:                                                                  |
        Иконки - FlatIcon (http://www.flaticon.com/categories/)                   |
                     Freepik (http://www.freepik.com)                             |
                     Yannick (http://yanlu.de)                                    |
                     Zurb (http://www.zurb.com)                                   |
                     Elegant Themes (http://www.elegantthemes.com)                |
                         лицензия: http://creativecommons.org/licenses/by/3.0/    |
        Фон - Pawel Kadysz (https://tookapic.com/pawelkadysz/10163-hello)         |
        Слайдер - Flickity (http://flickity.metafizzy.co/)                        |
                      David DeSandro (http://desandro.com/)                       |
                          лицензия: https://www.gnu.org/licenses/gpl-3.0.html     |
                                                                                  |
  Адаптация шаблона: Impera CMS                                                   |
                                                                                  |
  ------------------------------------------------------------------------------- |
                                                                                  |
  Codrops - англоязычный блог о веб дизайне и разработке, где публикуются статьи  |
  и руководства о свежих тенденциях в веб-мире, технических приёмах и новых       |
  возможностях. Команда Codrops преданно готовит полезный, вдохновляющий и        |
  новаторский контент, который бесплатен.                                         |
                                                                                  |
  ------------------------------------------------------------------------------- |
                                                                                  |
  Impera CMS - лёгкий и мощнейший скрипт магазина с потрясающими возможностями.   |
  Здесь запросто получается то, что в конкурирующих продуктах требует усилий.     |
                                                                                  |
================================================================================ */



    /* ============================================================================
    |                                                                             |
    |  Переменные автокликера (должны быть глобальными).                          |
    |                                                                             |
    ============================================================================ */

    var autoClickWaiting = true;
    var autoClickHandlerId = null;
    var autoClickScrollHandlerId = null;
    if (typeof autoClickScrollTargetSelector == 'undefined') {
        var autoClickScrollTargetSelector = '';
    }

    (function () {
        var bodyEl = document.body,
            docElem = window.document.documentElement,
            support = { transitions: Modernizr.csstransitions },

            /* имя финального события перехода */

            transEndEventNames = { 'WebkitTransition': 'webkitTransitionEnd',
                                   'MozTransition': 'transitionend',
                                   'OTransition': 'oTransitionEnd',
                                   'msTransition': 'MSTransitionEnd',
                                   'transition': 'transitionend' },
            transEndEventName = transEndEventNames[ Modernizr.prefixed( 'transition' ) ],

            onEndTransition = function ( el, callback ) {
                var onEndCallbackFn = function ( ev ) {
                    if (support.transitions) {
                        if (ev.target != this) return;
                        this.removeEventListener( transEndEventName, onEndCallbackFn );
                    }
                    if (callback && typeof callback === 'function') callback.call(this);
                };
                if (support.transitions) {
                    el.addEventListener( transEndEventName, onEndCallbackFn );
                }
                else {
                    onEndCallbackFn();
                }
            },

            slider = document.querySelector('.stack-slider'),
            stacksWrapper = slider.querySelector('.wrapper'),
            stacks = [].slice.call(stacksWrapper.children),
            imghero = document.querySelector('.hero__back--mover'),
            flkty,
            canOpen = true,
            canMoveHeroImage = true,
            isFirefox = typeof InstallTrigger !== 'undefined',

            win = { width: window.innerWidth,
                    height: window.innerHeight };

        function scrollY () {
            return window.pageYOffset || docElem.scrollTop;
        }

        /* from http://www.sberry.me/articles/javascript-event-throttling-debouncing */

        function throttle ( fn, delay ) {
            var allowSample = true;

            return function ( e ) {
                if (allowSample) {
                    allowSample = false;
                    setTimeout(function () { allowSample = true; }, delay);
                    fn(e);
                }
            };
        }

        function init() {
            flkty = new Flickity(stacksWrapper, {
                wrapAround: true,
                imagesLoaded: true,
                initialIndex: 0,
                setGallerySize: false,
                pageDots: false,
                prevNextButtons: false
            });

            /* ====================================================================
            |                                                                     |
            |  Обработчик "все изображения пачек загружены".                      |
            |                                                                     |
            ==================================================================== */

            imagesLoaded(stacksWrapper, function () {
                classie.add(bodyEl, 'view-init');

                /* теперь автокликер может продолжать */

                autoClickWaiting = false;
            });

            initEvents();
        }

        function initEvents () {
            stacks.forEach(function (stack) {
                var titleEl = stack.querySelector('h2');

                /* ================================================================
                |                                                                 |
                |  Разворот / сворачивание пачки.                                 |
                |                                                                 |
                ================================================================ */

                if (titleEl != null) {
                    titleEl.addEventListener('click', function ( ev ) {
                        ev.preventDefault();

                        /* если это текущая пачка */

                        if (classie.has(stack, 'is-selected')) {

                            /* если пачка развернута  */

                            if (classie.has(bodyEl, 'view-full')) {
                                var closeStack = function () {
                                    classie.remove(bodyEl, 'move-items');

                                    onEndTransition(slider, function () {
                                        classie.remove(bodyEl, 'view-full');
                                        bodyEl.style.height = '';
                                        flkty.bindDrag();
                                        flkty.options.accessibility = true;
                                        canMoveHeroImage = true;
                                    });
                                };

                                /* если пользователь прокручивал вниз, сначала крутим все вверх перед сворачиванием пачки */

                                var scrolled = scrollY();
                                if (scrolled > 0) {
                                    smooth_scroll_to(isFirefox ? docElem : bodyEl || docElem, 0, 500).then(function () {
                                        closeStack();
                                    });
                                } else {
                                    closeStack();
                                }

                            /* если пачка свернута */

                            } else if (canOpen) {
                                canMoveHeroImage = false;
                                classie.add(bodyEl, 'view-full');
                                setTimeout(function () { classie.add(bodyEl, 'move-items'); }, 25);
                                bodyEl.style.height = stack.offsetHeight + 'px';
                                flkty.unbindDrag();
                                flkty.options.accessibility = false;
                            }
                        } else if (classie.has(stack, 'stack-prev')) {
                            flkty.previous(true);
                        } else if (classie.has(stack, 'stack-next')) {
                            flkty.next(true);
                        }
                    });

                    titleEl.addEventListener('mouseenter', function ( ev ) {
                        if (classie.has(stack, 'is-selected')) {
                            canMoveHeroImage = false;
                            imghero.style.WebkitTransform = 'perspective(1000px) translate3d(0, 0, 0) rotate3d(1, 1, 1, 0deg)';
                            imghero.style.transform = 'perspective(1000px) translate3d(0, 0, 0) rotate3d(1, 1, 1, 0deg)';
                        }
                    });

                    titleEl.addEventListener('mouseleave', function ( ev ) {

                        /* если это текущая папка и она не развернута */

                        if (classie.has(stack, 'is-selected') && !classie.has(bodyEl, 'view-full')) {
                            canMoveHeroImage = true;
                        }
                    });
                }
            });

            /* ====================================================================
            |                                                                     |
            |  Обработка отклика фонового изображения на позицию курсора.         |
            |                                                                     |
            ==================================================================== */

            window.addEventListener('mousemove', throttle(function ( ev ) {
                if (!canMoveHeroImage) return false;
                var xVal = -1 / (win.height / 2) * ev.clientY + 1,
                    yVal = 1 / (win.width / 2) * ev.clientX - 1,
                    transX = 20 / (win.width) * ev.clientX - 10,
                    transY = 20 / (win.height) * ev.clientY - 10,
                    transZ = 100 / (win.height) * ev.clientY - 50;

                imghero.style.WebkitTransform = 'perspective(1000px) translate3d(' + transX + 'px, ' + transY + 'px, ' + transZ + 'px) rotate3d(' + xVal + ', ' + yVal + ', 0, 2deg)';
                imghero.style.transform = 'perspective(1000px) translate3d(' + transX + 'px, ' + transY + 'px, ' + transZ + 'px) rotate3d(' + xVal + ', ' + yVal + ', 0, 2deg)';
            }, 100));

            /* ====================================================================
            |                                                                     |
            |  Обработка изменения размера окна.                                  |
            |                                                                     |
            ==================================================================== */

            window.addEventListener('resize', throttle(function ( ev ) {
                win = { width: window.innerWidth,
                        height: window.innerHeight };

                /* если пачка развернута */

                if (classie.has(bodyEl, 'view-full')) {
                    bodyEl.style.height = stacks[flkty.selectedIndex].offsetHeight + 'px';
                }
            }, 50));

            /* ====================================================================
            |                                                                     |
            |  События Flickity.                                                  |
            |                                                                     |
            ==================================================================== */

            flkty.on('cellSelect', function () {
                canOpen = false;
                classie.remove(bodyEl, 'item-clickable');

                var prevStack = stacksWrapper.querySelector('.stack-prev'),
                    nextStack = stacksWrapper.querySelector('.stack-next'),
                    selidx = flkty.selectedIndex,
                    cellsCount = flkty.cells.length,
                    previdx = selidx > 0 ? selidx - 1 : cellsCount - 1;
                    nextidx = selidx < cellsCount - 1 ? selidx + 1 : 0;

                if (prevStack) {
                    classie.remove(prevStack, 'stack-prev');
                } if (nextStack) {
                    classie.remove(nextStack, 'stack-next');	
                }

                classie.add(stacks[previdx], 'stack-prev');
                classie.add(stacks[nextidx], 'stack-next');
            });

            flkty.on('dragStart', function () {
                canOpen = false; 
                classie.remove(bodyEl, 'item-clickable');
            });

            flkty.on('settle', function () { 
                classie.add(bodyEl, 'item-clickable');
                canOpen = true; 
            });
        }

        /* ========================================================================
        |                                                                         |
        |  Принудительно кликаем AutoClick-элемент, если такой есть на странице.  |
        |                                                                         |
        ======================================================================== */

        function autoClickHandler () {
            if (autoClickHandlerId != null) {
                if (!autoClickWaiting) {
                    clearInterval(autoClickHandlerId);
                    autoClickHandlerId = null;
                    var el = document.getElementById('autoclick');
                    if (el != null && 'click' in el) {
                        el.click();
                        if (autoClickScrollTargetSelector != '') {
                            autoClickScrollHandlerId = setInterval(autoClickScrollHandler, 1000);
                        }
                    }
                }
            }
        }

        function autoClickScrollHandler () {
            if (autoClickScrollHandlerId != null) {
                clearInterval(autoClickScrollHandlerId);
                autoClickScrollHandlerId = null;
                if (autoClickScrollTargetSelector != '') scrollToObject(autoClickScrollTargetSelector);
            }
        }

        autoClickHandlerId = setInterval(autoClickHandler, 500);

        /* ========================================================================
        |                                                                         |
        |  Стартуем.                                                              |
        |                                                                         |
        ======================================================================== */

        init();
    }) ();

    /* ============================================================================
    |                                                                             |
    |  Откат по истории страниц на 1 назад.                                       |
    |                                                                             |
    ============================================================================ */

    function backHistory () {
        try {
            history.back();
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка смены количества товара в корзине.                               |
    |                                                                             |
    ============================================================================ */

    function changeCartQuantity ( select ) {
        try {
            var el = closestParentTag(select, 'form');
            if (el != null) el.submit();
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка смены способа доставки.                                          |
    |                                                                             |
    ============================================================================ */

    function changeCartDelivery ( radio ) {
        try {
            var el = closestParentTag(radio, 'form');
            if (el != null) {
                var input = el.querySelector('input[data-name="delivery_sum_now"]');
                if (input != null) {
                    var sum = radio.getAttribute('data-price');
                    if (sum != input.value) el.submit();
                }
            }
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка клика ссылки "оформить заказ".                                   |
    |                                                                             |
    ============================================================================ */

    function submitCart ( anchor ) {
        try {
            var el = closestParentTag(anchor, 'form');
            if (el != null) {
                var input = el.querySelector('input[name="submit_order"]');
                if (input != null) {
                    input.value = 1;
                    el.submit();
                }
            }
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка клика ссылки "найти".                                            |
    |                                                                             |
    ============================================================================ */

    function submitSearch ( anchor ) {
        try {
            var el = closestParentTag(anchor, 'form');
            if (el != null) el.submit();
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка клика ссылки "повторить поиск".                                  |
    |                                                                             |
    ============================================================================ */

    function repeatSearch ( anchor ) {
        try {
            var el = document.querySelector('form.search');
            if (el != null) {
                var input = el.querySelector('input[name="keyword"]');
                if (input != null) {
                    input.value = anchor.innerHTML;
                    el.submit();
                }
            }
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Получить ближайший родитель конкретного типа (тега) или NULL.              |
    |                                                                             |
    ============================================================================ */

    function closestParentTag ( child, tagname ) {
        try {
            tagname = tagname.toLowerCase();
            while (child != document.body) {
                child = child.parentNode;
                if ('tagName' in child && child.tagName.toLowerCase() == tagname) return child;
            }
        } catch (e) { }
        return null;
    }

    /* ============================================================================
    |                                                                             |
    |  Получить ближайший родитель конкретного класса или NULL.                   |
    |                                                                             |
    ============================================================================ */

    function closestParentClass ( child, classname ) {
        try {
            while (child != document.body) {
                child = child.parentNode;
                if ('classList' in child && child.classList.contains(classname)) return child;
            }
        } catch (e) { }
        return null;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка клика ссылки "напомнить текст комментария".                      |
    |                                                                             |
    ============================================================================ */

    function remindComment ( anchor ) {
        try {
            var el = closestParentTag(anchor, 'h5');
            if (el != null) {
                if (el.classList.contains('remind')) el.classList.remove('remind');
                else el.classList.add('remind');
            }
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Обработка клика ссылки "ответить" для комментария.                         |
    |                                                                             |
    ============================================================================ */

    function replyComment ( anchor, id ) {
        try {
            var box = closestParentClass(anchor, 'item');
            if (box != null) {
                var items = box.querySelectorAll('.reply');
                for (var i = 0; i < items.length; i++) items[i].classList.remove('reply');

                var el = closestParentTag(anchor, 'div');
                if (el != null) {
                    el.classList.add('reply');

                    var hint = el.innerHTML;
                    while ((el = hint.replace(/<[^>]*>/g, ' ')) != hint) hint = el;

                    box = box.querySelector('form');
                    if (box != null) {

                        el = box.querySelector('input[name="post_parent_id"]');
                        if (el != null) {
                            el.value = id;
                        }

                        el = box.querySelector('h5');
                        if (el != null) {
                            el.classList.add('reply');
                            el.innerHTML = '<a href="/" onclick="return remindComment(this)" class="flaticon-search" title="Напомнить текст комментария, на который я отвечаю"></a>Ответить на выделенный комментарий';
                            el.setAttribute('title', hint);

                            scrollToObject(box);
                        }
                    }
                }
            }
        } catch (e) { }
        return false;
    }

    /* ============================================================================
    |                                                                             |
    |  Прокрутка страницы до конкретного элемента (может быть указан селектором). |
    |                                                                             |
    ============================================================================ */

    function scrollToObject ( el ) {
        try {
            if (typeof el == 'string') el = document.querySelector(el);
            if ('offsetTop' in el) {
                var items = document.querySelectorAll('html, body');
                for (var i = 0; i < items.length; i++) items[i].scrollTop = el.offsetTop;
            }
        } catch (e) { }
        return false;
    }
